'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _lodash = require('lodash');

var _graphqlRelay = require('graphql-relay');

var _node = require('./../node');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var LoaderFilter = function () {
  function LoaderFilter(results) {
    var filtering = arguments.length <= 1 || arguments[1] === undefined ? {} : arguments[1];

    _classCallCheck(this, LoaderFilter);

    this.results = results;
    this.filtering = _extends({
      limit: 40,
      orderBy: {},
      filter: {},
      paginate: null
    }, filtering);
  }

  _createClass(LoaderFilter, [{
    key: 'toObject',
    value: function toObject() {
      if ((0, _lodash.isObject)(this.results)) {
        return this.results;
      }
      if (Array.isArray(this.results)) {
        var result = this.toArray();
        return result[0] || {};
      }

      throw new Error("Couldn't transform result to Object");
    }

    /**
     * Resolve results with filtering
     * applyed
     * @returns {Array|*}
     */

  }, {
    key: 'toArray',
    value: function toArray() {
      var results = void 0;
      if (!Array.isArray(this.results)) {
        results = [this.results];
      } else {
        results = this.results;
      }
      var _filtering = this.filtering;
      var index = _filtering.index;
      var offset = _filtering.offset;
      var orderBy = _filtering.orderBy;
      var filter = _filtering.filter;

      var resultFiltered = (0, _lodash.chain)(results);

      if (Object.keys(orderBy).length > 0) {
        resultFiltered = resultFiltered.orderBy(orderBy);
      }

      if (Object.keys(filter).length > 0) {
        resultFiltered = resultFiltered.filter(filter);
      }

      resultFiltered = resultFiltered.take(offset - index);

      return resultFiltered.value();
    }

    /**
     * Returned a connection from
     * array
     */

  }, {
    key: 'toConnectionArray',
    value: function toConnectionArray(args) {
      var results = this.toArray();
      return (0, _graphqlRelay.connectionFromArray)(results, args);
    }

    /**
     * Limit
     * @param limit
     * @returns {LoaderFilter}
     */

  }, {
    key: 'limit',
    value: function limit(_limit) {
      this.filtering.limit = _limit || this.filtering.limit;
      return this;
    }

    /**
     * Set order by
     * @param field
     * @param direction
     */

  }, {
    key: 'orderBy',
    value: function orderBy(field, direction) {
      this.filtering.orderBy[field] = direction;
      return this;
    }

    /**
     *
     * @param filterDef
     */

  }, {
    key: 'filter',
    value: function filter(filterDef) {
      this.filtering.filter = _extends({}, this.filtering.filter, filterDef);
      return this;
    }

    /**
     * Filter if helper
     * @param condition
     * @param filter
     * @returns {LoaderFilter}
     */

  }, {
    key: 'filterIf',
    value: function filterIf(condition, filter) {
      var _this = this;

      return this.if(condition, function () {
        return _this.filter(filter);
      });
    }

    /**
     * Sometime we use optional
     * arguments into our GraphQL queries
     * to keep the chain of filters
     * we use this function to evaluate
     * any filtering if the value is not
     * undefined
     * @param value
     * @param fnEvaluation
     * @returns {LoaderFilter}
     */

  }, {
    key: 'if',
    value: function _if(value, fnEvaluation) {
      if (value !== undefined) {
        fnEvaluation(this);
        return this;
      }
      return this;
    }

    /**
     * From node args
     *
     * @param args
     * @returns {LoaderFilter}
     */

  }, {
    key: 'fromNodeArgs',
    value: function fromNodeArgs(args) {
      var _this2 = this;

      this.filter(args.filter);

      this.if(args.order, function () {
        _this2.orderBy.apply(_this2, args.order);
      });

      this.limit(args.limit);

      return this;
    }
  }]);

  return LoaderFilter;
}();

exports.default = LoaderFilter;